/*************************************************
JavaScript for Adobe Illustrator CS2 ( Win / Mac )

■■ハガキ宛名作成■■

タブ区切りまたはカンマ区切りのテキストを
読み込んで、宛名を自動的に作成します。
その他、各種テキストの自動流し込みにも使えます。

作成者：倉田タカシ
「イラレで便利」 http://d-p.2-d.jp/ai-js/
2008_10_12	v1.2		改行文字の検出方法を変更
2007_01_06	v1.1		データ読み込みのバグを修正
2006_12_30	v1.0
*************************************************/

//////必要に応じてここを書き換えてください////////////////////

var tmLayerName = "[js] hagaki template" ;	// テンプレートレイヤーの名前
var tbLayerName = "[js] hagaki textboxes" ;	// テキストボックスレイヤーの名前
var txLayerName = "[js] hagaki texts" ;	// データ配置レイヤーの名前
var dTxtName = "desc text" ;
var pTxtName = "pref text" ;

//////////////////////////////////////////////////////////////

var osStr = $.os.slice( 0 , 3 ) ;
var aiVersion = version.slice(0,2) ;

var crCode = String.fromCharCode(13);
var lfCode = String.fromCharCode(10);
var tabCode = String.fromCharCode(9) ;
var enterCode = String.fromCharCode( 3 ) ;

var itemsArray = new Array() ;	// 各テキストデータを格納
var dataArray = new Array() ;	// 各テキストボックスを格納

var txtPref = new Object() ;	// 説明・設定テキストの書式
txtPref.kind = TextType.POINTTEXT ;

var tBoxPref = new Object() ;	// テキストボックスの書式
tBoxPref.width = 200 ;
tBoxPref.height = 20 ;


//////////////////////////////////////////////////////////////
// メイン処理

// 書類が開かれているか、保存されているか、ディレクトリが拾えるか
var mFlg = false ;
if( documents.length == 0 ){ alert( msg("no_files") ) }
else
{
	pFolder = getParentFolder( activeDocument ) ;
	if( pFolder.exists ){ mFlg = true }
}

while( mFlg )
{
	// テンプレートレイヤーがあるか
	try{ var l = activeDocument.layers[ tmLayerName ] }
	catch(e){
		if( ! activeDocument.saved )
		{
			if( confirm( msg( "not_saved" ) ) ){ activeDocument.save() }
		}
		setPrefText(); alert( msg( "set1" ) ) ;
		break }

	// テキストがすでに流し込まれているか
	try{ var l = activeDocument.layers[ tmLayerName ].layers[ tbLayerName ] }
	catch(e){ setTxtBoxes() ;  break }

	// 流し込まれていたら、印刷手続きへ
	try{ var l = activeDocument.layers[ txLayerName ] }
	catch(e){ importText( false ) ;  break }

	gotoPrint() ;
	mFlg = false ;
}

////////////////////////////////////////////////////////////////////////

// テンプレート作成・設定用テキスト配置
function setPrefText()
{
	tLayer = activeDocument.layers.add() ;
	tLayer.name = tmLayerName ;
	tLayer.printable = false ;

	descText = setText( tLayer , msg( "desc1" ) , txtPref ) ;
	descText.position = [ 50 , activeDocument.height ] ;
	descText.name = dTxtName ;
	prefText = setText( tLayer , msg( "pref" ) , txtPref ) ;
	prefText.position = [ 50 , activeDocument.height - descText.height - 50 ] ;
	prefText.name = pTxtName ;
}

// テンプレートにテキストボックス作成
function setTxtBoxes()
{
	// テキストからパラメーター取得
	var pref = getParam( pTxtName ) ;

	tFlg = confirm( msg( "import1" ) + pref.dataFileName + msg( "setTxtBx" ) ) ;
	if( tFlg )
	{
		// 仮テキスト読み込み
		pFolder = getParentFolder( activeDocument ) ;
		tx = readTxtFile( pFolder , pref.dataFileName ) ;
	}
	if( tFlg  &&   tx != "" )
	{
		//breakChar = chkBreak( tx ) ;
		itemsArray = tx.split( eval( chkBreak( tx ) ) );
		splitChar = chkSplitter( itemsArray[0] ) ;
		itemsNameArray = itemsArray[0].split( splitChar ) ;
		tA = itemsArray[1].split( splitChar ) ;

		// テキストボックス配置
		tBoxLayer = activeDocument.layers[ tmLayerName ].layers.add() ;
		tBoxLayer.name = tbLayerName ;

		for( i=0; i<tA.length; i++ )
		{
			tB = setTextBox( tBoxLayer , tA[i] , tBoxPref ) ;
			tB.position = [ 10 , ( activeDocument.height - 20*(i+1) ) ] ;
			tB.name = itemsNameArray[i] ;
			tB.selected = true ;
		}
		activeDocument.layers[ tmLayerName ].pageItems[ dTxtName ].contents = msg( "desc2" ) ;
	}
	else if ( ! tFlg ) { alert( msg( "cancelled" ) ) }
}

// データ読み込み・レイヤー複製・テキスト流し込み
function importText( lFlg )
{
	var pref = getParam( pTxtName ) ;	// 設定値の拾いなおし

	tFlg = confirm( msg( "import1" ) + pref.dataFileName + msg( "import2" ) ) ;
	if( tFlg )
	{
		pFolder = getParentFolder( activeDocument ) ;
		tx = readTxtFile( pFolder , pref.dataFileName ) ;
	}
	if( tFlg  &&  tx != "" )
	{
		if( lFlg )	// すでに流し込みレイヤーがある場合
		{
			ol = activeDocument.layers[ txLayerName ] ;
			if( confirm( msg( "deleteTexts" ) ) )	// 確認後、レイヤーを削除
			{ ol.remove() }
			else	// 削除しない場合はレイヤーをリネーム
			{
				ol.name += "_old" ;
				ol.visible = false ;  ol.locked = true ;
			}
		}
		
		pFolder = getParentFolder( activeDocument ) ;
		tx = readTxtFile( pFolder , pref.dataFileName ) ;
		
		itemsArray = tx.split( eval( chkBreak( tx ) ) );
		splitChar = chkSplitter( itemsArray[0] ) ;	// １行目を項目名として取り出し
		itemsNameArray = itemsArray[0].split( splitChar ) ;
		itemsArray.shift() ;
		if( itemsArray[ itemsArray.length-1 ] == "" ){ itemsArray.pop() }	// 末尾の改行への対応
		for( i=0; i<itemsArray.length; i++ )
		{
			a = itemsArray[i].split( splitChar ) ;
			itemsArray[i] = a ;
		}
		
		// 要素の数だけレイヤーを作成・テキスト複製
		// 文字を挿入
		// プリント可能であることを示すマーカーを挿入
		tL = activeDocument.layers.add() ;
		tL.name = txLayerName ;
		activeDocument.layers[ tmLayerName ].layers[ tbLayerName ].visible = true ;
		for( i=0; i<itemsArray.length; i++ )
		{
			dL = tL.layers.add() ;
			dL.name = "item_" + (i+1) ;
			for( j=0; j<itemsNameArray.length; j++ )
			{
				tB = activeDocument.layers[ tmLayerName ].layers[ tbLayerName ].pageItems[ itemsNameArray[j] ].duplicate() ;
				tB.moveToEnd( dL ) ;
				tB.contents = itemsArray[i][j] ;
			}
		}

		activeDocument.layers[ tmLayerName ].layers[ tbLayerName ].visible = false ;
		activeDocument.layers[ tmLayerName ].pageItems[ dTxtName ].contents = msg( "desc3" ) ;
		alert( msg( "imported" ) ) ;
	}
	else if ( ! tFlg ) { alert( msg( "cancelled" ) ) }
}

// プリント
function gotoPrint()
{
	var pref = getParam( pTxtName ) ;	// 設定値の拾いなおし
	
	// プリントするかどうか確認
	var pFlg = confirm( msg( "printOrNot" ) ) ;
	if( pFlg )
	{
		pL = activeDocument.layers[ txLayerName ] ;
		for( i=0; i<pL.layers.length; i++ )
		{ pL.layers[i].visible = false }
		for( i=0; i<pL.layers.length; i++ )
		{
			pL.layers[i].visible = true ;
			doPrint( activeDocument , pref.sheetNum ) ;
			pL.layers[i].visible = false ;
		}
	}
	else
	{
		importText( true ) ;
	}
}


////////////////////////////////////////////////////////////////////////

// データテキストの改行文字を調べる
function chkBreak( str )
{
	cA = [] ;
	cA[0] = new Object; cA[0].l = str.split( crCode ).length; cA[0].c = "crCode";
	cA[1] = new Object; cA[1].l = str.split( lfCode ).length; cA[1].c = "lfCode";
	cA[2] = new Object; cA[2].l = str.split( enterCode ).length; cA[2].c = "enterCode";
	function sOrder(a,b){ return b["l"] - a["l"] }
	cA.sort(sOrder) ;
	return cA[0].c ;
}

// データテキストの区切り文字を調べる
function chkSplitter( str )
{
	sA = str.split( "," ) ;
	sB = str.split( tabCode ) ;
	sA.length >= sB.length ?  s = "," : s = tabCode ;
	return s ;
}

// 外部テキスト読み込み（Stringを返す）
function readTxtFile( fFolder , fName )
{
	//oFile = fFolder.getFiles( fName )[0] ;
	oFile = new File( fFolder.fullName + "/" + fName ) ;
	if( oFile.exists )
	{
		oFlg = oFile.open("r","","") ;
		if( oFlg ){ return oFile.read() ; }
		else{ alert( msg( "err4" ) + msg( "err6" ) ) ;  return "" ; }
	}
	else{ alert( msg( "err4" ) + msg( "err6" ) ) ;  return "" ; }
}

// テキストオブジェクトを作成
function setText( target , str , txtPref )
{
	if( aiVersion == "10" ) { txObj = target.textArtItems.add() }
	else { txObj = target.textFrames.add() }
	
	if( txtPref != undefined )
	{
		for( var pc in txtPref ){ txObj[pc] = txtPref[pc] }
	}
	txObj.contents = str ;

	return txObj ;
}

// 流し込み用のテキストボックスを作成
function setTextBox( target , str , txtPref )
{
	if( aiVersion == "10" )
	{
		txObj = target.textArtItems.add() ;
		txObj.contents = str ;
		txObj.kind = TextType.AREATEXT ;
		txObj.textPaths[0].textPathObject.width = txtPref.width ;
		txObj.textPaths[0].textPathObject.height = txtPref.height ;
		return txObj ;
	}
	else
	{
		bPass = target.pathItems.rectangle( 0 , 0 , txtPref.width , txtPref.height ) ;
		txObj = target.textFrames.areaText( bPass ) ;
		txObj.contents = str ;
		return txObj ;
	}
}

// 枚数を指定して印刷
function doPrint( pDoc , sheetNum , pPref )
{
	if( aiVersion == "10" )
	{
		for( var pc=0; pc<sheetNum; pc++ )
		{
			pDoc.print( false ) ;
		}
	}
	else
	{
		pOpt = new PrintOptions ;
		pj = new PrintJobOptions ;
		pj.copies = sheetNum ;
		pOpt.jobOptions = pj ;
		pDoc.print( pOpt ) ;
	}

	if( pPref != undefined )
	{}
}


// 親フォルダを取得
function getParentFolder( docToGet/*Document*/ ) /* returns Folder */
{
	dirStr = docToGet.path.toString() ;
	parentFolder = new Folder( dirStr ) ;
	
	//ディレクトリの文字列チェック
	var sFlg = checkStrForJ( dirStr ) ;
	
	if( sFlg || ( (osStr == "Win") && ! sFlg ) )
	{
		if( ! parentFolder.exists )
		{ alert( msg("err1") + msg("err2") ) }	// ファイルの上書きが必要
		
		// ファイルが拾えるかどうかの確認
		fArray = parentFolder.getFiles();
		fileObj = new File( fArray[0].fsName );
		if( ! fileObj.exists )
		{
			if( ! sFlg )
			{ alert( msg("err1") + msg("err3") ) ;  alert( msg("err5") + msg("err2") ) }
			// 2バイト文字
			else{ alert( msg("err1") + msg("err2") ) }// ファイル上書き
			parentFolder = "" ;
		}
	}
	// Mac環境でディレクトリ名に2バイト文字が混入していたら無条件にアウト
	else if( (osStr == "Mac") && ! sFlg )
	{ alert( msg("err1") + msg("err3") ) ; }

	return parentFolder ;
}

// 文字列から2バイト文字の有無を検出
function checkStrForJ( stringToCheck )
{
	stringToCheck = stringToCheck.split("/").join("").split(".").join("").split("-").join("").split("_").join("").split(" ").join("");
	stringToCheck.match( /[^0-9a-zA-Z]/ ) ? jStrFlg = false : jStrFlg = true ;
	return jStrFlg ;
}

// ドキュメント上のテキストからパラメータを取得
function getParam( targetName )
{
	var splitC = ":" ;

	tx = activeDocument.pageItems[ targetName ].contents ;
	txArray = tx.split( enterCode ).join( crCode ).split( crCode ) ;
	pObj = new Object() ;
	// １行目は説明文として、無視して読み込む
	for( var tc=1; tc<txArray.length; tc++ )
	{
		t = txArray[tc].slice( 0 , txArray[tc].indexOf( tabCode ) ) ;
		tA = t.split( splitC ) ;
		pObj[ tA[0] ] = tA[1] ;
	}

	return pObj ;
}


////////////////////////////////////////////////////////////////////////

// メッセージ
function msg( msgType )
{

switch( msgType )
{
case "desc1" : mA = [
		"■ハガキ宛名作成・手順その１■",
		"用意したデータのファイル名の通りに",
		"下の設定用テキストのファイル名の部分を書き換え、",
		"もう一度スクリプトを実行してください。",
		"テンプレートを作成します。",
		"このテキストと設定用テキストは",
		"同じレイヤー内ならどこにでも移動できますが、",
		"削除はしないでください。" ] ; break ;
case "desc2" : mA = [
		"■ハガキ宛名作成・手順その２■",
		"テキストボックスの形と書式を調整してから",
		"もう一度スクリプトを実行してください。",
		"残りのデータをすべて読み込みます。",
		"ちなみに、文字単位での詰め等の調整は反映されません。" ] ; break ;
case "desc3" : mA = [
		"■ハガキ宛名作成・手順その３■",
		"各レイヤーを確認して、文字があふれていたら修正してください。",
		"もう一度スクリプトを実行すると、印刷にうつります。" ] ; break ;
case "pref" : mA = [
		"■ハガキ宛名支援・設定用テキスト■",
		"dataFileName:data.txt	←読み込むデータのファイル名（拡張子つき・半角英数字）",
		"sheetNum:1	←印刷する枚数" ] ; break ;

case "set1" : mA = [
		"設定用テキストを配置しました。これを書き変えて再度スクリプトを実行してください。" ] ; break ;
case "setTxtBx" : mA = [
		" 」から文字データを読み込み、テキスト用のテンプレートを配置します。" ] ; break ;
case "txtSet" : mA = [
		"テンプレートを配置しました。テキストボックスを調節してから、もう一度スクリプトを実行すると、データをすべて読み込みます。" ] ; break ;
case "import1" : mA = [
		"ファイル「 " ] ; break ;
case "import2" : mA = [
		" 」から文字データを読み込みます。" ] ; break ;
case "deleteTexts" : mA = [
		"前回読み込んだ文字データを削除しますか？" ] ; break ;
case "imported" : mA = [
		"データの読み込みが完了しました。各レイヤーを確認して、文字を調節してください。もう一度スクリプトを実行すると、印刷手続きに移ります。" ] ; break ;
case "printOrNot" : mA = [
		"プリントするときは「はい」を、データを読み込み直すときは「いいえ」をクリックしてください。" ] ; break ;
case "cancelled" : mA = [
		"データの読み込みはキャンセルされました。" ] ; break ;

case "no_files" : mA = [
		"まず、処理するファイルを開いてください。" ] ; break ;
case "not_saved" : mA = [
			"ファイルの変更が保存されていません。保存するときは「はい」をクリックしてください。" ] ; break ;
case "err1" : mA = [
		"■エラー■ 親フォルダの場所を取得できません。 " ] ; break ;
case "err2" : mA = [
		" このファイルを、「別名で保存...」で同じ場所に同名で上書きしてください。" ] ; break ;
case "err3" : mA = [
		" ディレクトリに日本語（2バイト文字）が含まれていないかどうかご確認ください。" ] ; break ;
case "err4" : mA = [
		"■エラー■ データの読み込みに失敗しました。" ] ; break ;
case "err5" : mA = [
		"ディレクトリに日本語が含まれていない場合は、" ] ; break ;
case "err6" : mA = [
		"ファイルが正しい場所にあるか、また、設定テキストにファイル名が正しく書かれているかどうか、確認してください。" ] ; break ;

}
	ms = mA.join( crCode ) ;
	return ms ;
}